#!/bin/sh

HERE=$(cd $(dirname $0); pwd -P)
FILE=cp2k-perf.txt
RUNS="23_23_23 4_6_9 13_5_7 24_3_36"

if [ "" != "$1" ]; then
  FILE=$1
  shift
fi
if [ "" != "$1" ]; then
  SIZE=$1
  shift
else
  SIZE=0
fi
cat /dev/null > ${FILE}

NRUN=1
NMAX=$(echo ${RUNS} | wc -w | tr -d ' ')
for RUN in ${RUNS} ; do
  MVALUE=$(echo ${RUN} | cut -d_ -f1)
  NVALUE=$(echo ${RUN} | cut -d_ -f2)
  KVALUE=$(echo ${RUN} | cut -d_ -f3)
  >&2 echo -n "${NRUN} of ${NMAX} (M=${MVALUE} N=${NVALUE} K=${KVALUE})... "
  ERROR=$({ CHECK=1 ${HERE}/cp2k.sh ${MVALUE} ${SIZE} 0 ${NVALUE} ${KVALUE} >> ${FILE}; } 2>&1)
  RESULT=$?
  if [ 0 != ${RESULT} ]; then
    echo "FAILED(${RESULT}) ${ERROR}"
    exit 1
  else
    echo "OK ${ERROR}"
  fi
  echo >> ${FILE}
  NRUN=$((NRUN+1))
done

