#!/bin/sh

HERE=$(cd $(dirname $0); pwd -P)
FILE=${HERE}/axhm-perf.txt
RUNS="4_6_9 8_8_8 13_13_13 16_8_13"

if [ "" != "$1" ]; then
  FILE=$1
  shift
fi
cat /dev/null > ${FILE}

NRUN=1
NMAX=$(echo ${RUNS} | wc -w | tr -d ' ')
for RUN in ${RUNS} ; do
  MVALUE=$(echo ${RUN} | cut -d_ -f1)
  NVALUE=$(echo ${RUN} | cut -d_ -f2)
  KVALUE=$(echo ${RUN} | cut -d_ -f3)
  >&2 echo -n "${NRUN} of ${NMAX} (M=${MVALUE} N=${NVALUE} K=${KVALUE})... "
  ERROR=$({ CHECK=1 ${HERE}/axhm.sh ${MVALUE} ${NVALUE} ${KVALUE} $* >> ${FILE}; } 2>&1)
  RESULT=$?
  if [ 0 != ${RESULT} ]; then
    echo "FAILED(${RESULT}) ${ERROR}"
    exit 1
  else
    echo "OK ${ERROR}"
  fi
  echo >> ${FILE}
  NRUN=$((NRUN+1))
done

